(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'function' && define.amd ? define(factory) :
  (global.vueModello = factory());
}(this, (function () { 'use strict';

  var installed = false;
  var _modelDirective = {
    install: function install(Vue) {
      if (installed) return;
      installed = true;

      // var directive = Vue.directive('model')
      // var _bind = directive.bind

      // directive.bind = function () {
      //   _bind.call(this)
      //
      //   let _setter = this.set
      //   this.set = function (...args) {
      //     try {
      //       writerState.isVModelDirWriting = true
      //       _setter.call(this, ...args)
      //     } finally {
      //       writerState.isVModelDirWriting = false
      //     }
      //   }
      // }
    }
  };

  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };

  var classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  var createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var defineProperty = function (obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  };

  var _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  var toConsumableArray = function (arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    } else {
      return Array.from(arr);
    }
  };

  function makeActionContext(mutations, state, dispatch) {
    var commit = makeCommitFn(state, mutations);
    return {
      state: state,
      dispatch: dispatch,
      commit: commit
    };
  }

  function makeCommitFn(state, mutations) {
    return function (mutationName) {
      if (mutations.hasOwnProperty(mutationName)) {
        var args = Array.from(arguments);
        args.shift(); // mutation name
        args.unshift(state);

        try {
          mutations[mutationName].apply(null, args);
        } finally {
        }
      }
    };
  }

  function getObjByPath(obj, path) {
    var names = path.split('.');
    var firstName = names.shift();
    var member = obj[firstName];
    if (member && names.length) {
      return getObjByPath(member, names.join('.'));
    }
    return member;
  }

  function createPathIfNone(obj, path) {
    var names = path.split('.');
    var firstName = names.shift();
    var member = obj[firstName];
    if (!member) member = obj[firstName] = {};
    if (names.length) {
      return createPathIfNone(member, names.join('.'));
    }
    return member;
  }

  function setObjByPath(obj, path, val, createPath) {
    var names = path.split('.');
    var lastName = names.pop();
    var parent = obj;

    if (names.length) {
      var parentPath = names.join('.');
      parent = createPath === true ? createPathIfNone(obj, parentPath) : getObjByPath(obj, parentPath);
    }

    if (parent) {
      parent[lastName] = val;
    }
  }

  function parseStatesOption() {
    var states = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    var fullInjectModules = [];
    var needInjectModules = [];
    var partialInjectPathesMap = {};
    var statePathes = [];

    states.forEach(function (s) {
      var type = typeof s === 'undefined' ? 'undefined' : _typeof(s);
      if (type === 'string') {
        if (s.includes('.')) {
          statePathes.push(s);
        } else {
          fullInjectModules.push(s);
        }
      } else if (s && type === 'object') {
        Object.assign(partialInjectPathesMap, s);
      }
    });

    statePathes.forEach(function (s) {
      var pathes = s.split('.');
      var moduleName = pathes.shift();

      if (!fullInjectModules.includes(moduleName)) {
        var moduleStates = partialInjectPathesMap[moduleName] || (partialInjectPathesMap[moduleName] = []);
        moduleStates.push(pathes.join('.'));
      }
    });

    Object.keys(partialInjectPathesMap).forEach(function (module) {
      if (fullInjectModules.includes(module)) {
        delete partialInjectPathesMap[module];
      } else {
        needInjectModules.push(module);
      }
    });

    needInjectModules = needInjectModules.concat(fullInjectModules);

    return {
      needInjectModules: needInjectModules,
      fullInjectModules: fullInjectModules,
      partialInjectPathesMap: partialInjectPathesMap
    };
  }

  function createModel() {
    var eventMap = {};

    var Model = function () {
      function Model(option) {
        classCallCheck(this, Model);

        Model.fire('init', option);

        var _ = this._ = {
          option: option,
          actions: {},
          mutations: {},
          watch: {},
          actionModMap: {},
          mutationModMap: {}
        };
        var mixins = option.mixins;
        var actions = _.actions,
            actionModMap = _.actionModMap,
            mutationModMap = _.mutationModMap,
            mutations = _.mutations;

        // mix module

        var types = ['actions', 'mutations', 'watch'];
        types.forEach(function (type) {
          // mix default module
          if (!option.hasOwnProperty(type)) {
            option[type] = {};
          }
          _[type].default = option[type];

          // mix naming modules
          for (var name in mixins) {
            var mod = mixins[name];
            if (!mod.hasOwnProperty(type)) mod[type] = {};
            _[type][name] = mod[type];
          }
        });

        Model.fire('mixed', function (handler) {
          handler(_.option);

          for (var mod in mixins) {
            handler(mixins[mod]);
          }
        }, this);

        // build action-->mod map

        var _loop = function _loop(mod) {
          Object.keys(actions[mod]).forEach(function (action) {
            actionModMap[action] = mod;
          });
        };

        for (var mod in actions) {
          _loop(mod);
        }

        // build mutation-->mod map

        var _loop2 = function _loop2(mod) {
          Object.keys(mutations[mod]).forEach(function (mutation) {
            mutationModMap[mutation] = mod;
          });
        };

        for (var mod in mutations) {
          _loop2(mod);
        }

        _.defaultStateKeys = [];
        var defaultState = this.getDefaultState();
        if ((typeof defaultState === 'undefined' ? 'undefined' : _typeof(defaultState)) === 'object' && defaultState) {
          _.defaultStateKeys = Object.keys(defaultState);
        }

        Model.fire('created', this);
      }

      createClass(Model, [{
        key: 'getDefaultState',
        value: function getDefaultState() {
          var _state = this._.option.state;
          return _state ? _state() : undefined;
        }
      }, {
        key: 'getModState',
        value: function getModState(mod) {
          if (mod === 'default') {
            return this.getDefaultState();
          }

          var mixins = this._.option.mixins;
          var modState = mixins[mod].state;
          return modState ? modState() : undefined;
        }

        // wrap all module state() in state

      }, {
        key: 'state',
        value: function state() {
          var result = this.getDefaultState();
          var mixins = this._.option.mixins;

          for (var mod in mixins) {
            var modState = this.getModState(mod);
            if (modState !== undefined) {
              if (!result) result = {};
              result[mod] = modState;
            }
          }

          return result;
        }
      }, {
        key: 'getStateActions',
        value: function getStateActions(state) {
          return this._.actions[state];
        }
      }, {
        key: 'eachStateWatch',
        value: function eachStateWatch(states, handle) {
          var watch = this._.watch;

          var _loop3 = function _loop3(_state2) {
            if (!states.includes(_state2)) return 'continue';

            var stateWatch = watch[_state2];
            if (!stateWatch) return 'continue';
            handle(_state2, function (eachWatcher) {
              for (var path in stateWatch) {
                var val = stateWatch[path];
                var handler = null;
                var option = {};

                if (typeof val === 'function') {
                  handler = val;
                } else {
                  // object
                  option = _extends({}, val);
                  handler = option.handler;
                  delete option.handler;
                }

                eachWatcher(path, handler, option);
              }
            });
          };

          for (var _state2 in watch) {
            var _ret3 = _loop3(_state2);

            if (_ret3 === 'continue') continue;
          }
        }
      }, {
        key: 'applyAction',
        value: function applyAction(state, action, args) {
          if (state !== 'default' && !this._.actions[state][action]) {
            state = 'default';
          }

          var result = this._.actions[state][action].apply(null, args);
          if (result && result.then) {
            return result;
          }
        }
      }, {
        key: 'commitMutation',
        value: function commitMutation(modStateName, mutation, args) {
          if (state !== 'default' && !this._.mutations[state][mutation]) {
            state = 'default';
          }

          var state = this.getState(modStateName);
          args.unshift(state);

          this._.mutations[state][mutation].apply(null, args);
        }
      }, {
        key: 'commit',
        value: function commit(mutation) {
          var modStateName = this._.mutationModMap[mutation];

          for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            args[_key - 1] = arguments[_key];
          }

          this.commitMutation(modStateName, mutation, args);
        }
      }, {
        key: 'dispatch',
        value: function dispatch(action) {
          var stateKey = this._.actionModMap[action];
          var state = this.getState(stateKey);

          var context = makeActionContext(this.getStateMutations(stateKey), state[stateKey], this.dispatch.bind(this));

          var BIZ_PARAM_INDEX = 1;
          var args = Array.from(arguments).slice(BIZ_PARAM_INDEX);
          args.unshift(context);

          var result = this.applyAction(stateKey, action, args);
          if (result && result.then) {
            return result.then(function () {
              return state;
            });
          }
        }
      }, {
        key: 'dispatchAll',
        value: function dispatchAll(fn) {
          var _this = this;

          var BIZ_PARAM_INDEX = 1;

          var callers = [];
          var subStates = new Set();
          var actionModMap = this._.actionModMap;

          function dispatch(action) {
            var stateKey = actionModMap[action];
            var args = Array.from(arguments).slice(BIZ_PARAM_INDEX);

            callers.push({ stateKey: stateKey, action: action, args: args });
            subStates.add(stateKey);
          }

          fn(dispatch);

          var state = this.getState([].concat(toConsumableArray(subStates)));

          return Promise.all(callers.map(function (_ref) {
            var stateKey = _ref.stateKey,
                action = _ref.action,
                args = _ref.args;

            var context = makeActionContext(_this.getStateMutations(stateKey), state[stateKey], _this.dispatch.bind(_this));
            args.unshift(context);

            return _this.applyAction(stateKey, action, args);
          })).then(function () {
            return state;
          });
        }
      }, {
        key: 'getStateMutations',
        value: function getStateMutations(state) {
          return this._.mutations[state];
        }
      }, {
        key: 'getState',
        value: function getState(states) {
          var _this2 = this;

          if (!states) {
            return this.state();
          }

          if (!Array.isArray(states)) {
            states = [states];
          }

          return states.reduce(function (result, mod) {
            var modState = _this2.getModState(mod);
            if (modState !== undefined) {
              if (!result) result = {};
              if (mod === 'default') {
                Object.assign(result, modState);
              } else {
                result[mod] = modState;
              }
            }
            return result;
          }, undefined);
        }
      }, {
        key: 'defaultStateKeys',
        get: function get$$1() {
          return this._.defaultStateKeys;
        }
      }, {
        key: 'modelName',
        get: function get$$1() {
          return this._.option.modelName;
        }
      }]);
      return Model;
    }();

    Model.on = function (event, handler) {
      eventMap[event] = eventMap[event] || [];
      eventMap[event].push(handler);
    };

    Model.fire = function (event) {
      for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      var observers = eventMap[event];
      if (observers) {
        observers.forEach(function (o) {
          return o.apply(undefined, args);
        });
      }
    };

    return Model;
  }

  var DEFAULT_MODULE = 'default';

  function makeActionDispatcher(vm, model, state, statePath) {
    var mutations = model.getStateMutations(state);

    return function dispatch(action) {
      var context = makeActionContext(mutations, getObjByPath(vm.$data, statePath), dispatch);

      var args = Array.from(arguments);
      args.shift();
      args.unshift(context);

      var result = model.applyAction(state, action, args);
      if (result && result.then) {
        return result;
      }
    };
  }

  function makeVueMixin (getModel) {
    return {
      beforeCreate: function beforeCreate() {
        var vm = this;
        var config = this.$options.modello;
        var computed = this.$options.computed || (this.$options.computed = {});
        if (!config) return;

        var models = [].concat(config);

        var existsDefaultModel = false;
        models.forEach(function (modelOption) {
          var model = modelOption.model,
              actions = modelOption.actions,
              _modelOption$mutation = modelOption.mutations,
              mutations = _modelOption$mutation === undefined ? [] : _modelOption$mutation,
              _modelOption$getters = modelOption.getters,
              getters = _modelOption$getters === undefined ? {} : _modelOption$getters,
              _modelOption$actionAl = modelOption.actionAlias,
              actionAlias = _modelOption$actionAl === undefined ? {} : _modelOption$actionAl,
              _modelOption$mutation2 = modelOption.mutationAlias,
              mutationAlias = _modelOption$mutation2 === undefined ? {} : _modelOption$mutation2;


          model = getModel(model);
          var states = modelOption.states;
          if (!modelOption.states) {
            states = [DEFAULT_MODULE];
          } else {
            states = parseStatesOption(modelOption.states).needInjectModules;
          }

          var modelName = model.modelName;

          // inject computed
          if (getters) {
            for (var computedName in getters) {
              computed[computedName] = new Function('return this.' + modelName + '.' + getters[computedName]);
            }
          }
          // actionMethod ({commit(mutation, ...args), state, dispatch(action, ...args)}, ...args)
          // mutationMethod (state, ...args)
          // inject actions and mutations as Vue method
          var methods = {};
          states.forEach(function (state) {
            var statePath = modelName;
            if (state !== DEFAULT_MODULE) {
              statePath += '.' + state;
            }

            // inject actions
            // all mudule actions will auto inject if no givens
            if (actions !== false) {
              var stateAllActions = Object.keys(model.getStateActions(state));
              var injectActions = stateAllActions;

              if (Array.isArray(actions)) {
                injectActions = actions.filter(function (_) {
                  return stateAllActions.includes(_);
                });
              } else if ((typeof actions === 'undefined' ? 'undefined' : _typeof(actions)) === 'object' && actions.hasOwnProperty(state)) {
                var stateActions = actions[state];
                if (Array.isArray(stateActions)) {
                  injectActions = stateActions.filter(function (_) {
                    return stateAllActions.includes(_);
                  });
                } else if (stateActions === false) {
                  injectActions = [];
                }
              }

              if (injectActions.length) {
                var dispatch = makeActionDispatcher(vm, model, state, statePath);

                injectActions.forEach(function (action) {
                  var methodName = actionAlias[action] || action;
                  methods[methodName] = dispatch.bind(null, action);
                });
              }
            }

            // inject mutations
            // mutation wont auto inject if no given
            if (Array.isArray(mutations) && mutations.length) {
              var stateMutations = model.getStateMutations(state);
              var stateMutationsNames = Object.keys(stateMutations);
              var injectMutations = mutations.filter(function (_) {
                return stateMutationsNames.includes(_);
              });

              if (injectMutations.length) {
                var stateCommit = function stateCommit() {
                  makeCommitFn(getObjByPath(vm.$data, statePath), stateMutations).apply(undefined, arguments);
                };
                injectMutations.forEach(function (mutation) {
                  if (!methods.hasOwnProperty(mutation)) {
                    var methodName = mutationAlias[mutation] || mutation;
                    methods[methodName] = stateCommit.bind(null, mutation);
                  }
                });
              }
            }
          });

          if ((modelOption.default || models.length === 1) && !existsDefaultModel) {
            existsDefaultModel = true;
            vm.$model = Object.assign({}, methods);
          } else {
            for (var m in methods) {
              if (!vm.$model[m]) {
                vm.$model[m] = methods[m];
              }
            }
          }
          vm.$model[modelName] = methods;
        });
      },
      data: function data() {
        var config = this.$options.modello;
        if (!config) return {};

        var models = [].concat(config);

        var result = {};
        models.forEach(function (option) {
          var model = getModel(option.model);
          var modelState = result[model.modelName] = {};
          var optionStates = option.states || [DEFAULT_MODULE];

          var _parseStatesOption = parseStatesOption(optionStates),
              fullInjectModules = _parseStatesOption.fullInjectModules,
              partialInjectPathesMap = _parseStatesOption.partialInjectPathesMap;

          // states: [{newPage: ['workorder', 'xxxx'}]


          var _loop = function _loop(mod) {
            var isDefaultMod = mod === DEFAULT_MODULE;
            var modState = void 0,
                filterState = void 0,
                setTarget = void 0;

            if (isDefaultMod) {
              modState = model.getState(DEFAULT_MODULE);
              setTarget = filterState = {};
            } else {
              modState = model.getState(mod)[mod];
              filterState = defineProperty({}, mod, {});
              setTarget = filterState[mod];
            }

            partialInjectPathesMap[mod].forEach(function (path) {
              var value = getObjByPath(modState, path);
              setObjByPath(setTarget, path, value, true);
            });

            Object.assign(modelState, filterState);
          };

          for (var mod in partialInjectPathesMap) {
            _loop(mod);
          }

          Object.assign(modelState, model.getState(fullInjectModules));
        });

        return result;
      },
      created: function created() {
        var config = this.$options.modello;
        if (!config) return;

        var models = [].concat(config);

        var vm = this;

        models.forEach(function (option) {
          var model = getModel(option.model);
          var modelName = model.modelName;
          var optionStates = option.states || [DEFAULT_MODULE];

          var _parseStatesOption2 = parseStatesOption(optionStates),
              needInjectModules = _parseStatesOption2.needInjectModules;

          var showMutateWarning = function showMutateWarning() {
            var isFirstMutate = arguments.length === 1;
            if (isFirstMutate) return;
          };

          vm.$watch(model.modelName, showMutateWarning, {
            deep: true,
            immediate: true,
            sync: true
          });

          // handle watch
          model.eachStateWatch(needInjectModules, function (state, watchEach) {
            var statePath = modelName;
            if (state !== DEFAULT_MODULE) {
              statePath += '.' + state;
            }

            var dispatch = makeActionDispatcher(vm, model, state, statePath);

            var statePrefix = statePath + '.';
            var len = statePrefix.length;

            watchEach(function (path, handler, option) {
              var listenOrWatch = vm.$listen ? '$listen' : '$watch';
              var watchPath = path === '$state' ? statePath : statePrefix + path;

              vm[listenOrWatch](watchPath, function (val, oldVal, path) {
                var mutations = model.getStateMutations(state);
                var context = makeActionContext(mutations, getObjByPath(vm.$data, statePath), dispatch);

                if (path) {
                  path = {
                    absolute: path.absolute.substr(len),
                    relative: path.relative
                  };
                }

                handler(context, val, oldVal, path);
              }, option);
            }); // end for stateWatch
          }); // end eachWatch
        }); // models.forEach
      } // created

    };
  }

  var Modello = function () {
    function Modello() {
      classCallCheck(this, Modello);

      this._ = {
        store: {},
        installed: false,
        model: createModel(),
        vuePlugin: makeVueMixin(this.getModel.bind(this))
      };
    }

    createClass(Modello, [{
      key: 'install',
      value: function install(vue) {
        if (this._.installed) return;

        vue.mixin(this.vuePlugin);
        vue.use(_modelDirective);

        this._.installed = true;
      }
    }, {
      key: 'getModel',
      value: function getModel(model) {
        return this._.store[model];
      }
    }, {
      key: 'use',
      value: function use(plugin) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        plugin.install.apply(plugin, [this].concat(args));
      }
    }, {
      key: 'reg',
      value: function reg(model) {
        var Model = this.Model;
        if (!(model instanceof Model)) {
          return this.reg(new Model(model));
        }
        this._.store[model.modelName] = model;
      }
    }, {
      key: 'unReg',
      value: function unReg(model) {
        var Model = this.Model;
        if (model instanceof Model) {
          delete this._.store[model.modelName];
        } else if (typeof model === 'string') {
          delete this._.store[model];
        }
      }
    }, {
      key: 'on',
      value: function on() {
        var _Model;

        return (_Model = this.Model).on.apply(_Model, arguments);
      }
    }, {
      key: 'vuePlugin',
      get: function get$$1() {
        return this._.vuePlugin;
      }
    }, {
      key: 'Model',
      get: function get$$1() {
        return this._.model;
      }
    }], [{
      key: 'modelDirective',
      value: function modelDirective() {
        return _modelDirective;
      }
    }]);
    return Modello;
  }();

  return Modello;

})));
